/*Ŀ
 ݳ                                                                      
 ݳ Program Name: BOX3D.PRG         Copyright: Gallagher Computing inc.  
 ݳ Date Created: 02/28/96           Language: Clipper 5.0               
 ݳ Time Created: 06:54:26             Author: Kevin S Gallagher         
 Ĵ
 ݳ The code in this file was hacked up from another project. So there   
 ݳ may be stuff that does not make sense, just bare with it...          
 ݳ                                                                      
 ݳ                                                                      
 
            */




#include "kg_chars.h"
#include "inkey.ch"

#define LONGEST_LINE 60

#command DEFAULT <var> TO <val>         ;
=>  if valtype(<var>) <> valtype(<val>) ;
    ; <var> := <val>                    ;
    ; endif

#define KEY_ARROWS  chr(26) + chr(24) + chr(25) + chr(27)
#xtranslate NtoS(<n>) => ltrim(str(<n>))


/*
*   Routine: Box3d(nTr,nTc,nBr,nBc,cBoxStr,acColor,lActive,lDouble,lShadow )
*          :
*   Purpose: Creates picture frame style box
*          :
* Arguments: <nTr>        top row to draw box
*          :
*          : <nTc>        top left column to start drawing box
*          :
*          : <nBr>        bottom row of box
*          :
*          : <nBc>        bottom right corner of box
*          :
*          : [<cBoxStr>]  character string used to draw box
*          :
*          : [<acColor>]  color for dispbox()
*          :
*          : [<lActive>]  abit different looking box
*          :
*          : [<lDouble>]  .T. double lines, .F. single lines
*          :
*          : [<lShadow>]  .T. a shadow is drawn around the box
*          :              .F. no shadow is used
*          :
*  Comments: Must redefine characters prior to calling this function 
*          :
*/
FUNCTION Box3D(nTr,nTc,nBr,nBc,cBoxStr,acColor,lActive,lDouble,lShadow )
    local nRow    := row()
    local nCol    := col()
    local nCursor := setcursor(0)

    default cBoxStr to BIGBOX

    dispbox(nTr,nTc,nBr,nBc,BIGBOX,acColor)

    devpos(nRow,nCol)
    setcursor(nCursor)
return nil

/*
*
*   Alert()
*
*   Purpose:  Replacement of Clipper's alert function
*     Usage:  alert(<cMessage>[,<aOptions_][,<aColorStr_>][,<nStartRow>])
*                       --> NUMERIC
*/
FUNCTION Alert(cMessage,aOptions_,aColorStr_,nStartRow,lShadow)
    local aTxtLines_ := {}
    local nResult    := 0
    local aSaveKey   := array(8)
    local nLongest
    local nTemp
    local nStart
    local cSaveColor
    local cSaveScreen
    local nTop
    local nLeft
    local nBottom
    local nRight
    local nSaveX
    local nSaveY
    local nNumLines
    local nRow
    local nStartSave
    local nN
    local nChoiceLines
    local nCols      := maxcol()
    local cSaveDev   := set(_SET_DEVICE,"SCREEN")
    local nSaveRow   := row()
    local nSaveCol   := col()
    local i
    local nlen

    default lShadow to .F.

    if valtype(aOptions_) <> "A"
        aOptions_ := {" Ok "}
    endif

    aTxtLines_ := ListAsArray(cMessage,";")

    nLongest := 0
    i := 1
    while i<= len(aTxtLines_)
        if (nTemp := len( aTxtLines_[i] )) >= LONGEST_LINE
            // Find first space prior to LONGEST_LINE to break the line
            nTemp := rat(" ",left(aTxtLines_[i],LONGEST_LINE))

            // If there is no space then just break the line???
            if nTemp == 0
                nTemp := LONGEST_LINE -5
            endif

            // No make the array larger and break up the line
            ains(aadd(aTxtLines_,""),i+1)
            aTxtLines_[i+1] := substr(aTxtLines_[i],nTemp+1)
            aTxtLines_[i]   := left(aTxtLines_[i],nTemp)
        endif

        // Now test for the longest
        if nTemp > nLongest
            nLongest := nTemp
        endif
        i++
    enddo

    nLongest += 10  // Add spaces to the longest line
    nTemp    := 2   // Now determine the length of the choices

    aeval(aOptions_,{|a| nTemp+=len(a)+4})
    nChoiceLine := 0

    if nTemp > LONGEST_LINE
        nStart := nStartSave := int((nCols-LONGEST_LINE+6)/2)
        nTemp  := 0
        for i := 1 to len(aOptions_)
            if nStart +len(aOptions_[i]) +2 >= LONGEST_LINE
                nTemp  := nStart -2
                nStart := nStartSave
                nChoiceLines++
            else
                nStart+=len(aOptions_[i]) +4
            endif
        next
    else
        nChoiceLines := 1
    endif

    if nTemp > nLongest
        nLongest := nTemp
    endif

    // Set colors and build the box
    // Note we use an array and limited errorchecking on the array
    if valtype(aColorStr_) == "A" .and. len(aColorStr_) == 3
        cSaveColor := setcolor(aColorStr_[3])
    else
        aColorStr_    := {nil,nil,nil}
        aColorStr_[1] := "r/w"          // or r/w* (box color)
        aColorStr_[2] := "w+/r"         //
        aColorStr_[3] := "w+/r,w+/b"    // text and buttons
        cSaveColor    := setcolor(aColorStr_[3])
    endif

    nNumLines := len(aTxtLines_)

    if valtype(nStartRow) <> "N"
        nTop := int((maxrow() -nNumLines -3) /2)
    else
        nTop := min(maxrow() -nNumLines -3,nStartRow)
    endif

    nBottom     := nTop +nNumLines +nChoiceLines +2
    nLeft       := int((nCols -nLongest) /2)
    nRight      := nLeft + nLongest
    cSaveScreen := savescreen(nTop, nLeft, nBottom +2, nRight +2)

    dispbegin()
    
    box3D(nTop,nLeft,nBottom,nRight,BIGBOX,aColorStr_[1],.t.,.f.)

    if lShadow
        ft_shadow(nTop,nLeft,nBottom,nRight)
    endif

    for i := 1 to nNumLines
        @ nTop+i, int((nCols-len(aTxtLines_[i]))/2) say aTxtLines_[i]
    next

    // Now use menu to to present options
    nStart := nStartSave := int((nCols-nTemp+6)/2)
    nRow   := nBottom - nChoiceLines

    for i := 1 to len(aOptions_)
        // Test for going beyond end of box
        if nStart + len(aOptions_[i]) + 2 >= nRight
            nRow++
            nStart := nStartSave
        endif
        // Now make menu
        @ nRow, nStart prompt " " + aOptions_[i] + " "
        nStart := col() +2
    next

    aSaveKey[1] := {32,    SETKEY( 32,   {|| __Keyboard(CHR(K_RETURN))})}
    aSaveKey[2] := {K_HOME,SETKEY(K_HOME,{|| nN :=0})}
    aSaveKey[3] := {K_END, SETKEY(K_END, {|| nN :=0})}
    aSaveKey[4] := {K_PGUP,SETKEY(K_PGUP,{|| nN :=0})}
    aSaveKey[5] := {K_PGDN,SETKEY(K_PGDN,{|| nN :=0})}
    aSaveKey[6] := {K_UP,  SETKEY(K_UP,  {|| nN :=0})}
    aSaveKey[7] := {K_DOWN,SETKEY(K_DOWN,{|| nN :=0})}

    dispend()

    menu to nResult

    // restore the mouse, keys and screen
    for i := 1 to 7
        setkey( aSaveKey[i,1], aSaveKey[i,2])
    next

    setcolor(cSaveColor)
    restscreen(nTop,nLeft,nBottom+2,nRight+2,cSaveScreen)
    devpos(nSaveRow,nSaveCol)
    set(_SET_DEVICE, cSaveDev)

return nResult


/*
*  ListAsArray( <cList>, <cDelimiter> ) --> aList
*  Convert a delimited string to an array - Taken from
*  CLIPPER5\SOURCE\STRING.PRG
*
*/
FUNCTION ListAsArray(cString, cDelim)
    LOCAL nPtr
    LOCAL aToken := {}

    cDelim  := IF(cDelim == NIL, " ", cDelim)
    cString := ALLTRIM(cString)

    WHILE (nPtr := AT(cDelim, cString)) != 0
        AADD(aToken, IF(nPtr > 1, RTRIM(LEFT(cString, nPtr-1)), ""))
        cString := IF(LEN(cString) > nPtr, LTRIM(SUBSTR(cString, nPtr+1)), "")
    ENDDO

    AADD(aToken, cString)

RETURN(aToken)

/*
STATIC FUNCTION ListAsArray( cList, cDelimiter )

    LOCAL nPos
    LOCAL aList := {}

    IF valtype(cDelimiter) <> "C"
        cDelimiter := ","
    ENDIF

    WHILE (nPos := at(cDelimiter, cList)) <> 0
        aadd(aList, substr(cList, 1, nPos - 1))
        cList := substr(cList, nPos + 1)
    ENDDO
    aadd(aList, cList)
RETURN aList
*/
function kg_BackColor( cColor )
    local cPrime  := ""
    local aColor_
    local bErHand := errorblock({|e| break(e)})
    local oMy

    begin sequence
        aColor_ := ListAsArray( cColor, "/" )
        cPrime  := left(aColor_[2],at(",",aColor_[2]) -1)
    recover using oMy
        if valtype(oMy) == "O"
            if oMy:subsystem == "BASE"
                cPrime := "R"
            endif
        endif
    end sequence
    errorblock(bErHand)
return upper(cPrime)

